xref: /titanic_51/usr/src/cmd/initpkg/umountall.sh (revision 753a6d457b330b1b29b2d3eefcd0831116ce950d)
17c478bd9Sstevel@tonic-gate#!/sbin/sh
27c478bd9Sstevel@tonic-gate#
37c478bd9Sstevel@tonic-gate# CDDL HEADER START
47c478bd9Sstevel@tonic-gate#
57c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
6ef4c14d2Ssetje# Common Development and Distribution License (the "License").
7ef4c14d2Ssetje# You may not use this file except in compliance with the License.
87c478bd9Sstevel@tonic-gate#
97c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
107c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
117c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
127c478bd9Sstevel@tonic-gate# and limitations under the License.
137c478bd9Sstevel@tonic-gate#
147c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
157c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
167c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
177c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
187c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
197c478bd9Sstevel@tonic-gate#
207c478bd9Sstevel@tonic-gate# CDDL HEADER END
217c478bd9Sstevel@tonic-gate#
227c478bd9Sstevel@tonic-gate#
234d53c7adSDan Price# Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
247c478bd9Sstevel@tonic-gate# Use is subject to license terms.
257c478bd9Sstevel@tonic-gate#
267c478bd9Sstevel@tonic-gate#	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T
277c478bd9Sstevel@tonic-gate#	  All Rights Reserved
287c478bd9Sstevel@tonic-gate#
297c478bd9Sstevel@tonic-gate#
307c478bd9Sstevel@tonic-gate
317c478bd9Sstevel@tonic-gateusage () {
327c478bd9Sstevel@tonic-gate	if [ -n "$1" ]; then
337c478bd9Sstevel@tonic-gate		echo "umountall: $1" 1>&2
347c478bd9Sstevel@tonic-gate	fi
355fad3adeSPavel Filipensky	echo "Usage:\n\tumountall [-k] [-s] [-F FSType] [-l|-r] [-Z] [-n]" 1>&2
365fad3adeSPavel Filipensky	echo "\tumountall [-k] [-s] [-h host] [-Z] [-n]" 1>&2
377c478bd9Sstevel@tonic-gate	exit 2
387c478bd9Sstevel@tonic-gate}
397c478bd9Sstevel@tonic-gate
407c478bd9Sstevel@tonic-gateMNTTAB=/etc/mnttab
417c478bd9Sstevel@tonic-gate
427c478bd9Sstevel@tonic-gate# This script is installed as both /sbin/umountall (as used in some
437c478bd9Sstevel@tonic-gate# /sbin/rc? and /etc/init.d scripts) _and_ as /usr/sbin/umountall (typically
447c478bd9Sstevel@tonic-gate# PATHed from the command line).  As such it should not depend on /usr
457c478bd9Sstevel@tonic-gate# being mounted (if /usr is a separate filesystem).
467c478bd9Sstevel@tonic-gate#
477c478bd9Sstevel@tonic-gate# /sbin/sh Bourne shell builtins we use:
487c478bd9Sstevel@tonic-gate#	echo
497c478bd9Sstevel@tonic-gate#	exit
507c478bd9Sstevel@tonic-gate#	getopts
517c478bd9Sstevel@tonic-gate#	test, [ ]
527c478bd9Sstevel@tonic-gate#	exec
537c478bd9Sstevel@tonic-gate#	read
547c478bd9Sstevel@tonic-gate#
557c478bd9Sstevel@tonic-gate# /sbin commands we use:
567c478bd9Sstevel@tonic-gate#	/sbin/uname
577c478bd9Sstevel@tonic-gate#	/sbin/umount
587c478bd9Sstevel@tonic-gate#
597c478bd9Sstevel@tonic-gate# The following /usr based commands may be used by this script (depending on
607c478bd9Sstevel@tonic-gate# command line options).  We will set our PATH to find them, but where they
617c478bd9Sstevel@tonic-gate# are not present (eg, if /usr is not mounted) we will catch references to
627c478bd9Sstevel@tonic-gate# them via shell functions conditionally defined after option processing
637c478bd9Sstevel@tonic-gate# (don't use any of these commands before then).
647c478bd9Sstevel@tonic-gate#
657c478bd9Sstevel@tonic-gate#	Command		Command line option and use
667c478bd9Sstevel@tonic-gate# /usr/bin/sleep	-k, to sleep after an fuser -c -k on the mountpoint
677c478bd9Sstevel@tonic-gate# /usr/sbin/fuser	-k, to kill processes keeping a mount point busy
687c478bd9Sstevel@tonic-gate#
697c478bd9Sstevel@tonic-gate# In addition, we use /usr/bin/tail if it is available; if not we use
707c478bd9Sstevel@tonic-gate# slower shell constructs to reverse a file.
717c478bd9Sstevel@tonic-gate
727c478bd9Sstevel@tonic-gatePATH=/sbin:/usr/sbin:/usr/bin
737c478bd9Sstevel@tonic-gate
7476bc4030SnadkarniDEFERRED_ACTIVATION_PATCH_FLAG="/var/run/.patch_loopback_mode"
7576bc4030SnadkarniSVC_STARTD="/lib/svc/bin/svc.startd"
7676bc4030Snadkarni
777c478bd9Sstevel@tonic-gate# Clear these in case they were already set in our inherited environment.
787c478bd9Sstevel@tonic-gateFSType=
797c478bd9Sstevel@tonic-gateFFLAG=
807c478bd9Sstevel@tonic-gateHOST=
817c478bd9Sstevel@tonic-gateHFLAG=
827c478bd9Sstevel@tonic-gateRFLAG=
837c478bd9Sstevel@tonic-gateLFLAG=
847c478bd9Sstevel@tonic-gateSFLAG=
857c478bd9Sstevel@tonic-gateKFLAG=
865fad3adeSPavel FilipenskyZFLAG=
877c478bd9Sstevel@tonic-gateNFLAG=
887c478bd9Sstevel@tonic-gateLOCALNAME=
897c478bd9Sstevel@tonic-gateUMOUNTFLAG=
907c478bd9Sstevel@tonic-gate
917c478bd9Sstevel@tonic-gate
925fad3adeSPavel Filipenskywhile getopts ?rslkF:h:Zn c
937c478bd9Sstevel@tonic-gatedo
947c478bd9Sstevel@tonic-gate	case $c in
957c478bd9Sstevel@tonic-gate	r)	RFLAG="r";;
967c478bd9Sstevel@tonic-gate	l)	LFLAG="l";;
977c478bd9Sstevel@tonic-gate	s)	SFLAG="s";;
987c478bd9Sstevel@tonic-gate	k)	KFLAG="k";;
997c478bd9Sstevel@tonic-gate	h)	if [ -n "$HFLAG" ]; then
1007c478bd9Sstevel@tonic-gate			usage "more than one host specified"
1017c478bd9Sstevel@tonic-gate		fi
1027c478bd9Sstevel@tonic-gate		HOST=$OPTARG
1037c478bd9Sstevel@tonic-gate		HFLAG="h"
1047c478bd9Sstevel@tonic-gate		LOCALNAME=`uname -n`
1057c478bd9Sstevel@tonic-gate		;;
1067c478bd9Sstevel@tonic-gate	F)	if [ -n "$FFLAG" ]; then
1077c478bd9Sstevel@tonic-gate			usage "more than one FStype specified"
1087c478bd9Sstevel@tonic-gate		fi
1097c478bd9Sstevel@tonic-gate		FSType=$OPTARG
1107c478bd9Sstevel@tonic-gate		FFLAG="f"
1117c478bd9Sstevel@tonic-gate		case $FSType in
1127c478bd9Sstevel@tonic-gate		?????????*)
1137c478bd9Sstevel@tonic-gate			usage "FSType ${FSType} exceeds 8 characters"
1147c478bd9Sstevel@tonic-gate		esac;
1157c478bd9Sstevel@tonic-gate		;;
1165fad3adeSPavel Filipensky	Z)	ZFLAG="z";;
1177c478bd9Sstevel@tonic-gate	n)	NFLAG="n"
1187c478bd9Sstevel@tonic-gate		# Alias any commands that would perform real actions to
1197c478bd9Sstevel@tonic-gate		# something that tells what action would have been performed
1207c478bd9Sstevel@tonic-gate		UMOUNTFLAG="-V"
1217c478bd9Sstevel@tonic-gate		fuser () {
1227c478bd9Sstevel@tonic-gate			echo "fuser $*" 1>&2
1237c478bd9Sstevel@tonic-gate		}
1247c478bd9Sstevel@tonic-gate		sleep () {
1257c478bd9Sstevel@tonic-gate			: # No need to show where we'd sleep
1267c478bd9Sstevel@tonic-gate		}
1277c478bd9Sstevel@tonic-gate		;;
1287c478bd9Sstevel@tonic-gate	\?)	usage ""
1297c478bd9Sstevel@tonic-gate		;;
1307c478bd9Sstevel@tonic-gate	esac
1317c478bd9Sstevel@tonic-gatedone
1327c478bd9Sstevel@tonic-gate
1337c478bd9Sstevel@tonic-gate# Sanity checking:
1347c478bd9Sstevel@tonic-gate#	1) arguments beyond those supported
1357c478bd9Sstevel@tonic-gate#	2) can't specify both remote and local
1367c478bd9Sstevel@tonic-gate#	3) can't specify a host with -r or -l
1377c478bd9Sstevel@tonic-gate#	4) can't specify a fstype with -h
1387c478bd9Sstevel@tonic-gate#	5) can't specify this host with -h (checks only uname -n)
1397c478bd9Sstevel@tonic-gate#	6) can't be fstype nfs and local
1407c478bd9Sstevel@tonic-gate#	7) only fstype nfs is remote
1417c478bd9Sstevel@tonic-gate
1427c478bd9Sstevel@tonic-gateif [ $# -ge $OPTIND ]; then						# 1
1437c478bd9Sstevel@tonic-gate	usage "additional arguments not supported"
1447c478bd9Sstevel@tonic-gatefi
1457c478bd9Sstevel@tonic-gate
1467c478bd9Sstevel@tonic-gateif [ -n "$RFLAG" -a -n "$LFLAG" ]; then					# 2
1477c478bd9Sstevel@tonic-gate	usage "options -r and -l are incompatible"
1487c478bd9Sstevel@tonic-gatefi
1497c478bd9Sstevel@tonic-gate
1507c478bd9Sstevel@tonic-gateif [ \( -n "$RFLAG" -o -n "$LFLAG" \) -a "$HFLAG" = "h" ]; then		# 3
1517c478bd9Sstevel@tonic-gate	usage "option -${RFLAG}${LFLAG} incompatible with -h option"
1527c478bd9Sstevel@tonic-gatefi
1537c478bd9Sstevel@tonic-gate
1547c478bd9Sstevel@tonic-gateif [ -n "$FFLAG" -a "$HFLAG" = "h" ]; then				# 4
1557c478bd9Sstevel@tonic-gate	usage "Specifying FStype incompatible with -h option"
1567c478bd9Sstevel@tonic-gatefi
1577c478bd9Sstevel@tonic-gate
1587c478bd9Sstevel@tonic-gateif [ -n "$HFLAG" -a "$HOST" = "$LOCALNAME" ]; then			# 5
1597c478bd9Sstevel@tonic-gate	usage "Specifying local host illegal for -h option"
1607c478bd9Sstevel@tonic-gatefi
1617c478bd9Sstevel@tonic-gate
1627c478bd9Sstevel@tonic-gateif [ "$FSType" = "nfs" -a "$LFLAG" = "l" ]; then			# 6
1637c478bd9Sstevel@tonic-gate	usage "option -l and FSType nfs are incompatible"
1647c478bd9Sstevel@tonic-gatefi
1657c478bd9Sstevel@tonic-gate
1667c478bd9Sstevel@tonic-gateif [ -n "$FFLAG" -a "$FSType" != "nfs"  -a -n "$RFLAG" ]; then		# 7
1677c478bd9Sstevel@tonic-gate	usage "option -r and FSType ${FSType} are incompatible"
1687c478bd9Sstevel@tonic-gatefi
1697c478bd9Sstevel@tonic-gate
1707c478bd9Sstevel@tonic-gateZONENAME=`zonename`
1717c478bd9Sstevel@tonic-gate
17276bc4030Snadkarni#
17376bc4030Snadkarni# If we are in deferred activation patching, and the caller is
17476bc4030Snadkarni# svc.startd, then exit without unmounting any of the remaining
17576bc4030Snadkarni# file systems since the call path is from shutdown.  Note that
17676bc4030Snadkarni# by the time we get here, smf stop methods for nfs, cachefs
17776bc4030Snadkarni# etc, will have run.
17876bc4030Snadkarni#
17976bc4030Snadkarniif [ -f $DEFERRED_ACTIVATION_PATCH_FLAG ] ; then
18076bc4030Snadkarni	ppid=`ps -o ppid= -p $$`	# parent of umountall will be sh
18176bc4030Snadkarni					# from system()
18276bc4030Snadkarni
18376bc4030Snadkarni	ppid=`ps -o ppid= -p $ppid`	# parent of sh will be svc.startd
18476bc4030Snadkarni	COMM=`ps -o comm= -p $ppid`
18576bc4030Snadkarni	if [ "$COMM" = "$SVC_STARTD" ] ; then
18676bc4030Snadkarni		exit
18776bc4030Snadkarni	fi
18876bc4030Snadkarnifi
18976bc4030Snadkarni
1907c478bd9Sstevel@tonic-gate#
1917c478bd9Sstevel@tonic-gate# Take advantage of parallel unmounting at this point if we have no
1927c478bd9Sstevel@tonic-gate# criteria to match and we are in the global zone
1937c478bd9Sstevel@tonic-gate#
1945fad3adeSPavel Filipenskyif [ -z "${SFLAG}${LFLAG}${RFLAG}${HFLAG}${KFLAG}${FFLAG}${ZFLAG}" -a \
1957c478bd9Sstevel@tonic-gate    "$ZONENAME" = "global" ]; then
1967c478bd9Sstevel@tonic-gate	umount -a ${UMOUNTFLAG}
1977c478bd9Sstevel@tonic-gate	exit			# with return code of the umount -a
1987c478bd9Sstevel@tonic-gatefi
1997c478bd9Sstevel@tonic-gate
2007c478bd9Sstevel@tonic-gate#
2017c478bd9Sstevel@tonic-gate# Catch uses of /usr commands when /usr is not mounted
2027c478bd9Sstevel@tonic-gateif [ -n "$KFLAG" -a -z "$NFLAG" ]; then
2037c478bd9Sstevel@tonic-gate	if [ ! -x /usr/sbin/fuser ]; then
2047c478bd9Sstevel@tonic-gate		fuser () {
2057c478bd9Sstevel@tonic-gate			echo "umountall: fuser -k skipped (no /usr)" 1>&2
2067c478bd9Sstevel@tonic-gate			# continue - not fatal
2077c478bd9Sstevel@tonic-gate		}
2087c478bd9Sstevel@tonic-gate		sleep () {
2097c478bd9Sstevel@tonic-gate			: # no point in sleeping if fuser is doing nothing
2107c478bd9Sstevel@tonic-gate		}
2117c478bd9Sstevel@tonic-gate	else
2127c478bd9Sstevel@tonic-gate		if [ ! -x /usr/bin/sleep ]; then
2137c478bd9Sstevel@tonic-gate			sleep () {
2147c478bd9Sstevel@tonic-gate				echo "umountall: sleep after fuser -k skipped (no /usr)" 1>&2
2157c478bd9Sstevel@tonic-gate				# continue - not fatal
2167c478bd9Sstevel@tonic-gate			}
2177c478bd9Sstevel@tonic-gate		fi
2187c478bd9Sstevel@tonic-gate	fi
2197c478bd9Sstevel@tonic-gatefi
2207c478bd9Sstevel@tonic-gate
2217c478bd9Sstevel@tonic-gate#
2227c478bd9Sstevel@tonic-gate# Shell function to avoid using /usr/bin/cut.  Given a dev from a
2237c478bd9Sstevel@tonic-gate# fstype=nfs line in mnttab (eg, "host:/export) extract the host
2247c478bd9Sstevel@tonic-gate# component.
2257c478bd9Sstevel@tonic-gateprint_host () {
2267c478bd9Sstevel@tonic-gate	OIFS=$IFS
2277c478bd9Sstevel@tonic-gate	IFS=":"
2287c478bd9Sstevel@tonic-gate	set -- $*
2297c478bd9Sstevel@tonic-gate	echo $1
2307c478bd9Sstevel@tonic-gate	IFS=$OIFS
2317c478bd9Sstevel@tonic-gate}
2327c478bd9Sstevel@tonic-gate
2337c478bd9Sstevel@tonic-gate#
2347c478bd9Sstevel@tonic-gate# doumounts echos its return code to stdout, so commands used within
2357c478bd9Sstevel@tonic-gate# this function should take care to produce no other output to stdout.
2367c478bd9Sstevel@tonic-gatedoumounts () {
2377c478bd9Sstevel@tonic-gate	(
2387c478bd9Sstevel@tonic-gate	rc=0
2397c478bd9Sstevel@tonic-gate	fslist=""
24029937fd1SPavel Filipensky	nfslist=""
2417c478bd9Sstevel@tonic-gate	while read dev mountp fstype mode dummy
2427c478bd9Sstevel@tonic-gate	do
2437c478bd9Sstevel@tonic-gate		case "${mountp}" in
2447c478bd9Sstevel@tonic-gate		/			| \
2457c478bd9Sstevel@tonic-gate		/dev			| \
2467c478bd9Sstevel@tonic-gate		/dev/fd			| \
2477c478bd9Sstevel@tonic-gate		/devices		| \
2487c478bd9Sstevel@tonic-gate		/etc/mnttab		| \
2497c478bd9Sstevel@tonic-gate		/etc/svc/volatile	| \
2507c478bd9Sstevel@tonic-gate		/lib			| \
2517c478bd9Sstevel@tonic-gate		/proc			| \
2527c478bd9Sstevel@tonic-gate		/sbin			| \
2537c478bd9Sstevel@tonic-gate		/system/contract	| \
2547c478bd9Sstevel@tonic-gate		/system/object		| \
2557c478bd9Sstevel@tonic-gate		/tmp			| \
256*753a6d45SSherry Moore		/tmp/.libgrubmgmt*	| \
2577c478bd9Sstevel@tonic-gate		/usr			| \
2587c478bd9Sstevel@tonic-gate		/var			| \
2597c478bd9Sstevel@tonic-gate		/var/adm		| \
2607c478bd9Sstevel@tonic-gate		/var/run		| \
2617c478bd9Sstevel@tonic-gate		'' )
2627c478bd9Sstevel@tonic-gate			#
2637c478bd9Sstevel@tonic-gate			# file systems possibly mounted in the kernel or
2647c478bd9Sstevel@tonic-gate			# in the methods of some of the file system
2657c478bd9Sstevel@tonic-gate			# services
2667c478bd9Sstevel@tonic-gate			#
2677c478bd9Sstevel@tonic-gate			continue
2687c478bd9Sstevel@tonic-gate			;;
2697c478bd9Sstevel@tonic-gate		* )
2707c478bd9Sstevel@tonic-gate			if [ -n "$HFLAG" ]; then
2717c478bd9Sstevel@tonic-gate				if [ "$fstype" = "nfs" ]; then
2727c478bd9Sstevel@tonic-gate					thishost=`print_host $dev`
2737c478bd9Sstevel@tonic-gate					if [ "$HOST" != "$thishost" ]; then
2747c478bd9Sstevel@tonic-gate						continue
2757c478bd9Sstevel@tonic-gate					fi
2767c478bd9Sstevel@tonic-gate				else
2777c478bd9Sstevel@tonic-gate					continue
2787c478bd9Sstevel@tonic-gate				fi
2797c478bd9Sstevel@tonic-gate			fi
2807c478bd9Sstevel@tonic-gate			if [ -n "$FFLAG" -a "$FSType" != "$fstype" ]; then
2817c478bd9Sstevel@tonic-gate				continue
2827c478bd9Sstevel@tonic-gate			fi
2837c478bd9Sstevel@tonic-gate			if [ -n "$LFLAG" -a "$fstype" = "nfs" ]; then
28429937fd1SPavel Filipensky				nfslist="$nfslist $mountp"
2857c478bd9Sstevel@tonic-gate				continue
2867c478bd9Sstevel@tonic-gate			fi
28729937fd1SPavel Filipensky			#
28829937fd1SPavel Filipensky			# This will filter out autofs mounts with nfs file
28929937fd1SPavel Filipensky			# system mounted on the top of it.
29029937fd1SPavel Filipensky			#
29129937fd1SPavel Filipensky			# WARNING: use of any syscall on a NFS file system has
29229937fd1SPavel Filipensky			# the danger to go over-the-wire and could cause nfs
29329937fd1SPavel Filipensky			# clients to hang on shutdown, if the nfs server is
29429937fd1SPavel Filipensky			# down beforehand.
29529937fd1SPavel Filipensky			# For the reason described above, a simple test like
29629937fd1SPavel Filipensky			# "df -F nfs $mountp" can't be used to filter out
29729937fd1SPavel Filipensky			# nfs-over-autofs mounts. We loop over a list instead:
29829937fd1SPavel Filipensky			#
29929937fd1SPavel Filipensky			if [ -n "$LFLAG" -a -n "$nfslist" -a "$fstype" = "autofs" ]
30029937fd1SPavel Filipensky			then
30129937fd1SPavel Filipensky				for m in $nfslist; do
30229937fd1SPavel Filipensky					if [ "$mountp" = "$m" ]; then
30329937fd1SPavel Filipensky						# Resume the outer while loop
30429937fd1SPavel Filipensky						continue 2
30529937fd1SPavel Filipensky					fi
30629937fd1SPavel Filipensky				done
30729937fd1SPavel Filipensky			fi
3087c478bd9Sstevel@tonic-gate			if [ -n "$RFLAG" -a "$fstype" != "nfs" ]; then
3097c478bd9Sstevel@tonic-gate				continue
3107c478bd9Sstevel@tonic-gate			fi
3117c478bd9Sstevel@tonic-gate			if [ "$ZONENAME" != "global" ]; then
3127c478bd9Sstevel@tonic-gate				for option in `echo $mode | tr , '\012'`; do
3137c478bd9Sstevel@tonic-gate					#
3147c478bd9Sstevel@tonic-gate					# should not see any zone options
3157c478bd9Sstevel@tonic-gate					# but our own
3167c478bd9Sstevel@tonic-gate					#
3177c478bd9Sstevel@tonic-gate					if [ "$option" = "zone=$ZONENAME" ]; then
3187c478bd9Sstevel@tonic-gate						break
3197c478bd9Sstevel@tonic-gate					fi
3207c478bd9Sstevel@tonic-gate				done
3217c478bd9Sstevel@tonic-gate				if [ "$option" != "zone=$ZONENAME" ]; then
3227c478bd9Sstevel@tonic-gate					continue
3237c478bd9Sstevel@tonic-gate				fi
3245fad3adeSPavel Filipensky			# we are called from the global zone
3255fad3adeSPavel Filipensky			else
3265fad3adeSPavel Filipensky				for option in `echo $mode | tr , '\012'`; do
3275fad3adeSPavel Filipensky					case "$option" in
3285fad3adeSPavel Filipensky					zone=*)
3295fad3adeSPavel Filipensky						option="zone="
3305fad3adeSPavel Filipensky						break
3315fad3adeSPavel Filipensky					;;
3325fad3adeSPavel Filipensky					esac
3335fad3adeSPavel Filipensky				done
3345fad3adeSPavel Filipensky				# skip mounts from non-global zones if ZFLAG is not set
3355fad3adeSPavel Filipensky				if [ "$option" = "zone=" -a -z "$ZFLAG" ]; then
3365fad3adeSPavel Filipensky					continue
3375fad3adeSPavel Filipensky				fi
3385fad3adeSPavel Filipensky				# skip mounts from the global zone if ZFLAG is set
3395fad3adeSPavel Filipensky				if [ "$option" != "zone=" -a -n "$ZFLAG" ]; then
3405fad3adeSPavel Filipensky					continue
3415fad3adeSPavel Filipensky				fi
3427c478bd9Sstevel@tonic-gate			fi
3437c478bd9Sstevel@tonic-gate			if [ -n "${KFLAG}" ]; then
3447c478bd9Sstevel@tonic-gate				fuser -c -k $mountp 1>&2
3457c478bd9Sstevel@tonic-gate				sleep 2
3467c478bd9Sstevel@tonic-gate			fi
3477c478bd9Sstevel@tonic-gate			if [ -n "$SFLAG" ]; then
3487c478bd9Sstevel@tonic-gate				umount ${UMOUNTFLAG} ${mountp} 1>&2
3497c478bd9Sstevel@tonic-gate				trc=$?
3507c478bd9Sstevel@tonic-gate				if [ $trc -ne 0 ]; then
3517c478bd9Sstevel@tonic-gate					rc=$trc
3527c478bd9Sstevel@tonic-gate				fi
3537c478bd9Sstevel@tonic-gate			else
3547c478bd9Sstevel@tonic-gate				# We want to umount in parallel
3557c478bd9Sstevel@tonic-gate				fslist="$fslist $mountp"
3567c478bd9Sstevel@tonic-gate			fi
3577c478bd9Sstevel@tonic-gate		esac
3587c478bd9Sstevel@tonic-gate	done
3597c478bd9Sstevel@tonic-gate
3607c478bd9Sstevel@tonic-gate	if [ -n "$fslist" ]; then
3617c478bd9Sstevel@tonic-gate		umount -a ${UMOUNTFLAG} $fslist 1>&2
3627c478bd9Sstevel@tonic-gate		trc=$?
3637c478bd9Sstevel@tonic-gate		if [ $trc -ne 0 ]; then
3647c478bd9Sstevel@tonic-gate			rc=$trc
3657c478bd9Sstevel@tonic-gate		fi
3667c478bd9Sstevel@tonic-gate	fi
3677c478bd9Sstevel@tonic-gate
3687c478bd9Sstevel@tonic-gate	echo $rc
3697c478bd9Sstevel@tonic-gate	)
3707c478bd9Sstevel@tonic-gate}
3717c478bd9Sstevel@tonic-gate
3727c478bd9Sstevel@tonic-gate#
3737c478bd9Sstevel@tonic-gate# /etc/mnttab has the most recent mounts last.  Reverse it so that we
3747c478bd9Sstevel@tonic-gate# may umount in opposite order to the original mounts.
3757c478bd9Sstevel@tonic-gate#
3767c478bd9Sstevel@tonic-gate
3777c478bd9Sstevel@tonic-gateif [ ! -x /usr/bin/tail ]; then
3787c478bd9Sstevel@tonic-gate	exec < $MNTTAB
3797c478bd9Sstevel@tonic-gate	REVERSED=
3807c478bd9Sstevel@tonic-gate	while read line; do
3817c478bd9Sstevel@tonic-gate		if [ -n "$REVERSED" ]; then
3827c478bd9Sstevel@tonic-gate        		REVERSED="$line\n$REVERSED"
3837c478bd9Sstevel@tonic-gate		else
3847c478bd9Sstevel@tonic-gate			REVERSED="$line"
3857c478bd9Sstevel@tonic-gate		fi
3867c478bd9Sstevel@tonic-gate	done
3877c478bd9Sstevel@tonic-gate
3887c478bd9Sstevel@tonic-gate	error=`echo $REVERSED | doumounts`
3897c478bd9Sstevel@tonic-gateelse
3907c478bd9Sstevel@tonic-gate	error=`tail -r $MNTTAB | doumounts`
3917c478bd9Sstevel@tonic-gatefi
3927c478bd9Sstevel@tonic-gate
3937c478bd9Sstevel@tonic-gateexit $error
394